<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2007                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;    #securite

include_spip('inc/headers');
include_spip('inc/session');
include_spip('inc/cookie');
include_spip('inc/texte');

// http://doc.spip.org/@balise_URL_LOGOUT
function balise_LOGIN_CAS ($p) {return calculer_balise_dynamique($p,'LOGIN_CAS', array());
}

// $args[0] = url destination apres logout [(#URL_LOGOUT{url})]
// http://doc.spip.org/@balise_URL_LOGOUT_stat
function balise_LOGIN_CAS_stat ($args, $filtres) {
        return array($args[0]);
}

// http://doc.spip.org/@balise_URL_LOGOUT_dyn
function balise_LOGIN_CAS_dyn() {

	spip_log("CAS_PRIVATE : ".CAS_PRIVATE);

	// CAS n'est utilis� pour les authentifications de l'espace priv�
	if (!defined('CAS_PRIVATE') or !CAS_PRIVATE) 
	{
		return array('formulaires/cas', $GLOBALS['delais'],array('cas_url' => ''));
	}
	else 
	{
		
		casldap::casclient();

		// phpCAS::isAuthenticated() ne redirige pas automatiquement l'utilisateur
		// vers le backend si celui-ci dispose d'un ticket CAS valide
		// phpCAS::forceAuthentication() redirige automatiquement l'utilisateur
		// vers le backend si celui-ci dispose d'un ticket CAS valide mais
		// la fonctionnalit changer le login local ne fonctionne plus
		if (!phpCAS::isAuthenticated()) { 
			$url = phpCAS::getServerLoginURL();
			spip_log("[auth_cas] \$url =".$url);
	
			// Appeler le squelette formulaire_cas
			return array('formulaires/cas', $GLOBALS['delais'],array('cas_url' => $url));
		}
		else return login_cas();
	}	

}

function login_cas() {
	spip_log("Traitement login CAS");
// 	session_start();

	$login=phpCAS::getUser();
	spip_log("[auth_cas] authentification successful for user =".$login);

	// Si l'utilisateur figure deja dans la base, y recuperer les infos
	$result = spip_query("SELECT * FROM spip_auteurs WHERE login=" ._q($login). " AND statut<>'5poubelle'" );
	$row_auteur = spip_fetch_array($result);

	spip_log("[auth_cas] user attributes =".$row_auteur['login']);

	if ($row_auteur) {
		$GLOBALS['auteur_session'] =  $row_auteur;

		$session = charger_fonction('session', 'inc');

		$cookie_session = $session($row_auteur);


		spip_setcookie('spip_session', $cookie_session);

		$redirect = _DIR_RESTREINT_ABS. "?bonjour=oui";

		redirige_par_entete($redirect);

	}
	// Si l'auteur a un compte CAS qui n'existe pas dans la base SPIP
	else {	
		// Destruction de la session CAS :
		// si un utilisateur non autoris se connecte alors il vaut mieux dtruire
		// sa session CAS, car sinon il peut se connecter  d'autres applis par SSO
		// mme sans avoir pu se connecter  celle l.
		// TODO : mettre les 2 possibilits dans la config du plugin
		phpCAS::logout();
		// Jamais atteint
		return array('formulaires/cas', $GLOBALS['delais'],array('noauthz' => 1));
	}
}

?>
